--[[
		KAPIL'S INSANT HOUSE CONTRUCTION aka KIHC
		Version: 0. 1 Beta
		Edition: Hello MTA
		Author: Kapil
]]

IsHousePickup = { }
PlayerInHouse = { }
PlayerOutHouse = { }
HouseOutX =  { }
HouseOutY =  { }
HouseOutZ =  { }
HouseInX =  { }
HouseInY =  { }
HouseInZ =  { }
HouseInI =  { } 
id = { }
pickupCount = 0
houseElement = nil
PlayerBlip = { }
FirstCall = 0

function loadHouses()
	if FirstCall == 0 then
		local totalHouses = tonumber(loadData_kihc_load( "main" ,"houses" ))
		if totalHouses > 0 then
			local house = 0
			local x , y , z , ix , iy , iz , ii
			while house < totalHouses do
				house = house + 1
				x = loadData_kihc_load( "house"..tostring(house) , "positionx" )
				y = loadData_kihc_load( "house"..tostring(house) , "positiony" ) 
				z = loadData_kihc_load( "house"..tostring(house) , "positionz" )
				ix = loadData_kihc_load( "house"..tostring(house) , "positionix" )
				iy = loadData_kihc_load( "house"..tostring(house) , "positioniy" )
				iz = loadData_kihc_load( "house"..tostring(house) , "positioniz" )
				ii = loadData_kihc_load( "house"..tostring(house) , "positionii" )
				createHouse( x , y , z , ix , iy , iz , ii )
				print( " Loaded House "..tostring(house) )
			end
			print( " " )
		end
		FirstCall = 1
	end
end

function setHouseOwner( house , name )
	saveData_kihc( house , "owner" , name )
	saveData_kihc( name , "house" , house )
end

function setHouseTenent( house , name )
	saveData_kihc( name , "house" , house )
end

function removeHouseTenent( house , name )
	saveData_kihc( name ,"house" , "none" )
end

function setHouseCost( house , cost )
	saveData_kihc( house , "cost" , cost )
end

function setHouseRent( house , rent )
	saveData_kihc( house , "rent" , rent )
end

function getHouseOwner( house )
	return loadData_kihc( house , "owner" )
end

function getHouseCost( house )
	return tonumber(loadData_kihc( house , "cost" ))
end

function getHouseRent( house )
	return tonumber(loadData_kihc( house , "rent" ))
end

function getHouseBank( house )
	return tonumber(loadData_kihc( house , "bank" ))
end

function setHouseBank( house , bank )
	saveData_kihc( house , "bank" , bank )
end

function isPlayerOwner( house , name )
	if loadData_kihc( house , "owner" ) == name then
		return true
	else
		return false
	end	
end

function isPlayerTenent( house , name )
	if loadData_kihc( name , "house" ) == house then
		return true
	else
		return false
	end
end
	
function createHouse( x , y , z, ix, iy , iz , ii )
	local pickup = createPickup( x , y , z, 3 ,1273 )
	pickupCount = pickupCount + 1
	houseElement = "house"..pickupCount
	id[ pickup ] = houseElement
	HouseOutX[ houseElement ] = x
	HouseOutY[ houseElement ] = y
	HouseOutZ[ houseElement ] = z
	HouseInX[ houseElement ] = ix
	HouseInY[ houseElement ] = iy
	HouseInZ[ houseElement ] = iz
	HouseInI[ houseElement ] = ii
	IsHousePickup[ houseElement ] = true
	if existData_kihc( houseElement ) then
		-- nothing
	else
		createData_kihc( houseElement )
		saveData_kihc( houseElement , "owner" , "none" )
		saveData_kihc( houseElement , "cost" , "50000" )
		saveData_kihc( houseElement , "rent" , "50" )
		saveData_kihc( houseElement , "bank" , "0" )
	end

	return houseElement 	
end

function createHouseX( x , y , z, ix, iy , iz , ii , cost )
	local pickup = createPickup( x , y , z, 3 ,1273 )
	pickupCount = pickupCount + 1
	houseElement = "house"..pickupCount
	id[ pickup ] = houseElement
	HouseOutX[ houseElement ] = x
	HouseOutY[ houseElement ] = y
	HouseOutZ[ houseElement ] = z
	HouseInX[ houseElement ] = ix
	HouseInY[ houseElement ] = iy
	HouseInZ[ houseElement ] = iz
	HouseInI[ houseElement ] = ii
	IsHousePickup[ houseElement ] = true
	if existData_kihc( houseElement ) then
		-- nothing
	else
		createData_kihc( houseElement )
		saveData_kihc( houseElement , "owner" , "none" )
		saveData_kihc( houseElement , "cost" , cost )
		saveData_kihc( houseElement , "rent" , "50" )
		saveData_kihc( houseElement , "bank" , "0" )
	end

	return houseElement 	
end

function createHouseXX( x , y , z, ix, iy , iz , ii , cost , owner )
	local pickup = createPickup( x , y , z, 3 ,1273 )
	pickupCount = pickupCount + 1
	houseElement = "house"..pickupCount
	id[ pickup ] = houseElement
	HouseOutX[ houseElement ] = x
	HouseOutY[ houseElement ] = y
	HouseOutZ[ houseElement ] = z
	HouseInX[ houseElement ] = ix
	HouseInY[ houseElement ] = iy
	HouseInZ[ houseElement ] = iz
	HouseInI[ houseElement ] = ii
	IsHousePickup[ houseElement ] = true
	if existData_kihc( houseElement ) then
		-- nothing
	else
		createData_kihc( houseElement )
		saveData_kihc( houseElement , "owner" , owner )
		saveData_kihc( houseElement , "cost" , cost )
		saveData_kihc( houseElement , "rent" , "50" )
		saveData_kihc( houseElement , "bank" , "0" )
	end

	return houseElement 	
end

function onPlayerPickupUse_Event( pickup )
	if IsHousePickup[ id[pickup] ] then
	--	outputChatBox( "                  ----- [ House ] -----" , source )
		outputChatBox( "#00FF00 [ #FF9900/details#00FF00 ] - [  #FF9900/enter#00FF00 ]" , source, 255, 255, 255, true )
		outputChatBox( "#00FF00 [  #FF9900/buy#00FF00 ] - [  #FF9900/rent#00FF00 ]" , source, 255, 255, 255, true )
		--outputChatBox( " [ /rent ] - [ /unrent ]" , source )
		--outputChatBox( " [ /setrent ] - [ /withdraw ]" , source )
		PlayerOutHouse[ source ] = id[pickup]
	end
end

--    #00FF00   --  green
--    #FF9900    -- orange

function houseSystem( player , arg1 , arg2 )
	local sourceAccount = getClientAccount ( player )
	if not isGuestAccount( sourceAccount ) then
		if PlayerInHouse[ player ] then
			if arg1 == "buy" then
				if getHouseOwner( PlayerInHouse[ player ] ) == "none" then
					if getPlayerMoney( player ) > getHouseCost( PlayerInHouse[ player ] ) then
						local name = getClientName( player )
						setHouseOwner( PlayerInHouse[ player ] , name )
						outputChatBox( "#00FF00 Congrats, now you are the owner of this house." , player , 255, 255, 255, true)
						outputChatBox( "#00FF00 [  #FF9900/withdraw ] - ]  #FF9900/setrent ] - [  #FF9900/sell ]" , player , 255, 255, 255, true)
						takePlayerMoney( player , getHouseCost( PlayerInHouse[ player ] ))
						PlayerBlip[ player ] = createBlip( HouseOutX[ PlayerInHouse[ player ] ] , HouseOutY[ PlayerInHouse[ player ] ] , HouseOutZ[ PlayerInHouse[ player ] ] , 35 , 2 , 0 , 0 , 0 , 0 , 0 , player )
					else
						outputChatBox( "#00FF00 You dont have enough money." , player, 255, 255, 255, true )
					end
				else
					outputChatBox( "#00FF00    ." , player )				
				end
			elseif arg1 == "sell" then
				if arg2 ~= nil then
					local name = getClientName( player )
					if getHouseOwner( PlayerInHouse[ player ] ) == name then
						local toplayer = getPlayerFromNick( arg2 )
						if player ~= toplayer then
							if PlayerInHouse[ player ] == PlayerInHouse[ toplayer ] then
								setHouseOwner( PlayerInHouse[ player ] , arg2 )
								outputChatBox( "#00FF00 "..name.." has sold his house to you." , toplayer, 255, 255, 255, true )
								outputChatBox( "#00FF00 [  #FF9900/withdraw#00FF00 ] - ]  #FF9900/setrent#00FF00 ] - [  #FF9900/sell#00FF00 ]" , toplayer, 255, 255, 255, true )
								outputChatBox( "#00FF00 You have sold you house to "..arg2 , player, 255, 255, 255, true ) 
								setBlipIcon( PlayerBlip[ player ] , 0 )
								PlayerBlip[ toplayer ] = createBlip( HouseOutX[ PlayerInHouse[ player ] ] , HouseOutY[ PlayerInHouse[ player ] ] , HouseOutZ[ PlayerInHouse[ player ] ] , 35 , 2 , 255 , 0 , 0 , 255 , 0 , toplayer )
							else
								outputChatbox( "#00FF00 "..arg2.."     ." , player, 255, 255, 255, true )
							end
						else
							outputChatbox( "#00FF00 You cant sell your house to yourself." , player )
						end
					else
						outputChatBox( "#00FF00 You are not the owner of this house." , player, 255, 255, 255, true )
					end		
				else
					outputChatBox( "Usage: /sell <toOwnerName>" , player , 255, 255, 255, true)
				end
			elseif arg1 == "unrent" then
				local name = getClientName( player )
				if isPlayerOwner( PlayerInHouse[ player ] , name ) then
					outputChatBox( "#00FF00       ." , player, 255, 255, 255, true )
				else
					if isHouseTenent( PlayerInHouse[ player ] , player ) then
						setBlipIcon( PlayerBlip[ player ] , 0 )
						removeHouseTenent( PlayerInHouse[ player ] , name )
						outputChatBox( "#00FF00      .", player, 255, 255, 255, true )
					end
				end
			elseif arg1 == "setrent" then
				if arg2 ~= nil then
					local name = getClientName( player )
					if getHouseOwner( PlayerInHouse[ player ] ) == name then
						setHouseRent( PlayerInHouse[ player ] , arg2 )
						outputChatBox( "#00FF00       "..arg2..".", player, 255, 255, 255, true )
					else
						outputChatBox( "#00FF00    ." , player, 255, 255, 255, true )
					end
				else
					outputChatBox( "Usage: /setrent <newRent>" , player, 255, 255, 255, true )
				end				
			elseif arg1 == "withdraw" then
				local name = getClientName( player )
				if getHouseOwner( PlayerInHouse[ player ] ) == name then
					givePlayerMoney( player , getHouseBank( PlayerInHouse[ player ] ) )
					setHouseBank( PlayerInHouse[ player ] , "0" )
					outputChatBox( "#00FF00  ,    0." , player, 255, 255, 255, true )
				else
					outputChatBox( "#00FF00     ." , player, 255, 255, 255, true )
				end
			elseif arg1 == "rent" then
				if getHouseOwner( PlayerInHouse[ player ] ) ~= "none" then
					local name = getClientName( player )
					setHouseTenent( PlayerInHouse[ player ] , name )	
					outputChatBox( "#00FF00    ." , player, 255, 255, 255, true )
					outputChatBox( "#00FF00 [  #FF9900/unrent#00FF00 ] -      ." , player, 255, 255, 255, true )
					PlayerBlip[ player ] = createBlip( HouseOutX[ PlayerInHouse[ player ] ] , HouseOutY[ PlayerInHouse[ player ] ] , HouseOutZ[ PlayerInHouse[ player ] ] , 35 , 2 , 0 , 0 , 0 , 0 , 0 , player )
				else
					outputChatBox( "#00FF00      ." , player, 255, 255, 255, true )
				end
			elseif arg1 == "details" then
				outputChatBox( "#00FF00 [ Owner ] - [ Cost ] - [ Rent ]" , player, 255, 255, 255, true )
				outputChatBox( "#00FF00 [ "..getHouseOwner( PlayerInHouse[ player ] ).." ] - [ "..getHouseCost( PlayerInHouse[ player ] ).." ] - [ "..getHouseRent( PlayerInHouse[ player ] ).." ]" , player, 255, 255, 255, true )
			end		
		elseif PlayerOutHouse[ player ] then
			local x , y , z = getElementPosition( player )
			if getDistanceBetweenPoints3D(  x , y , z, HouseOutX[ PlayerOutHouse[ player ] ] , HouseOutY[ PlayerOutHouse[ player ] ] , HouseOutZ[ PlayerOutHouse[ player ] ] ) < 7 then
				if arg1 == "buy" then
					outputChatBox( "#00FF00    ." , player, 255, 255, 255, true )
				elseif arg1 == "sell" then
					outputChatBox( "#00FF00    ." , player, 255, 255, 255, true )
				elseif arg1 == "withdraw" then
					outputChatBox( "#00FF00    ." , player, 255, 255, 255, true )
				elseif arg1 == "setrent" then
					outputChatBox( "#00FF00    ." , player, 255, 255, 255, true )
				elseif arg1 == "unrent" then
					outputChatBox( "#00FF00    ." , player, 255, 255, 255, true )			
				elseif arg1 == "details" then
					outputChatBox( "#00FF00 [ Owner ] - [ Cost ] - [ Rent ]" , player, 255, 255, 255, true )
					outputChatBox( "#00FF00 [ "..getHouseOwner( PlayerOutHouse[ player ] ).." ] - [ "..getHouseCost( PlayerOutHouse[ player ] ).." ] - [ "..getHouseRent( PlayerOutHouse[ player ] ).." ]" , player, 255, 255, 255, true )
				elseif arg1 == "enter" then
					local name = getClientName( player )
					if getHouseOwner( PlayerOutHouse[ player ] ) == "none" then
						--fadeCamera( player , false , 0.5 )
						setElementInterior( player , HouseInI[ PlayerOutHouse[ player ] ] , HouseInX[ PlayerOutHouse[ player ] ] , HouseInY[ PlayerOutHouse[ player ] ] , HouseInZ[ PlayerOutHouse[ player ] ] )
						--fadeCamera( player , true , 0.5 )
						PlayerInHouse[ player ] = PlayerOutHouse[ player ]
						outputChatBox( "#00FF00 [  #FF9900/leave#00FF00 ] -  ." , player, 255, 255, 255, true )					
					elseif isPlayerTenent( PlayerOutHouse[ player ] , name ) then
						--fadeCamera( player , false , 0.5 )
						setElementInterior( player , HouseInI[ PlayerOutHouse[ player ] ] , HouseInX[ PlayerOutHouse[ player ] ] , HouseInY[ PlayerOutHouse[ player ] ] , HouseInZ[ PlayerOutHouse[ player ] ] )
						--fadeCamera( player , true , 0.5 )
						PlayerInHouse[ player ] = PlayerOutHouse[ player ]
						outputChatBox( "#00FF00  [  #FF9900/leave#00FF00 ] -  ." , player, 255, 255, 255, true )					
						--fadeCamera( player , true )
					end
				elseif arg1 == "rent" then
					if getHouseOwner( PlayerOutHouse[ player ] ) ~= "none" then
						local name = getClientName( player )
						setHouseTenent( PlayerOutHouse[ player ] , name )	
						outputChatBox( "#00FF00    ." , player, 255, 255, 255, true )
						outputChatBox( "#00FF00 [  #FF9900/unren#00FF00t ] - to unrent from this house." , player, 255, 255, 255, true )
						PlayerBlip[ player ] = createBlip( HouseOutX[ PlayerOutHouse[ player ] ] , HouseOutY[ PlayerOutHouse[ player ] ] , HouseOutZ[ PlayerOutHouse[ player ] ] , 35 , 2 , 0 , 0 , 0 , 0 , 0 , player )
					else
						outputChatBox( "#00FF00 This house is not rentable." , player, 255, 255, 255, true )
					end
				end
			else
				PlayerOutHouse[ player ] = nil
			end
		end
	end	
end

function leaveHouse( player , command )
	if PlayerInHouse[ player ] then
		setElementInterior( player , 0  ,HouseOutX[ PlayerInHouse[ player ] ] ,HouseOutY[ PlayerInHouse[ player ] ] , HouseOutZ[ PlayerInHouse[ player ] ] )
		PlayerInHouse[ player ] = nil
	end
end


function onPlayerSpawn_Event( )
	local name = getClientName( source )
	if existData_kihc( name ) then
		if loadData_kihc( name , "house" ) ~= "none" then
			local house = loadData_kihc( name , "house" )
			setElementInterior( source , HouseInI[ house ] , HouseInX[ house ] , HouseInY[ house ] , HouseInZ[ house ] )
			PlayerInHouse[ source ] = house
			outputChatBox( "#00FF00 [  #FF9900/leave#00FF00 ] - to leave the house." , source, 255, 255, 255, true )
			if getHouseOwner( house ) == name then
				PlayerBlip[ source ] = createBlip( HouseOutX[ house ] , HouseOutY[ house ] , HouseOutZ[ house ] , 35 , 2 , 0 , 0 , 0 , 0 , 0 , source )
			else
				PlayerBlip[ source ] = createBlip( HouseOutX[ house ] , HouseOutY[ house ] , HouseOutZ[ house ] , 35 , 2 , 0 , 0 , 0 , 0 , 0 , source )
				if getPlayerMoney( source ) > getHouseRent( house ) then
					takePlayerMoney( source , getHouseRent( house ) )
					setHouseBank( house , tostring(getHouseBank( house ) + getHouseRent( house )) )
					else
					removeHouseTenent( house , name )
					outputChatBox( "#00FF00 You are bankrupted, you no longer rent this house." , source, 255, 255, 255, true )
				end
			end
		end
	else
		createData_kihc( name )
		saveData_kihc( name , "house" , "none" )
	end
end

function createData_kihc_load( name )
	local file = xmlLoadFile( "kihc_houses.xml" )
	xmlCreateSubNode( file , name )
	xmlSaveFile( file )
end

function existData_kihc_load( name )
	local file = xmlLoadFile( "kihc_houses.xml"  )
	local found = xmlFindSubNode( file , name , 0 )
	if found then 
		return true
	else	
		return false
	end	
end 
 
function saveData_kihc_load( name , data , value )
	local file = xmlLoadFile( "kihc_houses.xml" )
	local player = xmlFindSubNode( file , name , 0 )
	local playerData = xmlFindSubNode( player , data , 0 )
	if playerData then
		--xmlDestroySubNode( player , data ) -------------------
		--local node = xmlCreateSubNode( player , data )
		xmlNodeSetAttribute( playerData , "value", value ) 
	else
		local node = xmlCreateSubNode( player , data )
		xmlNodeSetAttribute( node , "value", value )
	end
	xmlSaveFile( file )
end

function loadData_kihc_load( name , data )
	local file = xmlLoadFile( "kihc_houses.xml" )
	local player = xmlFindSubNode( file , name , 0 )
	local playerData = xmlFindSubNode( player , data , 0 )
	if playerData then
		return xmlNodeGetAttribute( playerData , "value" )
	else
		return false 
	end	
end

function createData_kihc( name )
	local file = xmlLoadFile( "kihc_database.xml" )
	local node = xmlCreateSubNode( file, "account"  )
	xmlNodeSetAttribute( node, "name" , name )
	xmlSaveFile( file )
	if node then
		return true
	else
		return false
	end	
end

function existData_kihc( name )
	local file = xmlLoadFile( "kihc_database.xml" )
	local count = 0
	local found = 1
	local node = 2
	while found ~= name do
		node = xmlFindSubNode( file, "account" , count )
		if not node then
			return false
		end
		found = xmlNodeGetAttribute( node, "name" )
		count = count + 1
		if not found then
			return false
		end
	end
	return true
end 
 
function saveData_kihc( name , key , value )
	local file = xmlLoadFile( "kihc_database.xml" )
	local count = 0
	local found = 1
	local node = 2
	while found ~= name do
		node = xmlFindSubNode( file, "account" , count )
		found = xmlNodeGetAttribute( node, "name" )
		count = count + 1
		if not found then
			return false
		end
	end
	xmlNodeSetAttribute( node , key , value )
	xmlSaveFile( file )
	return true
end

function loadData_kihc( name , key )
	local file = xmlLoadFile( "kihc_database.xml" )
	local count = 0
	local found = 1
	local node = 2
	while found ~= name do
		node = xmlFindSubNode( file, "account" , count )
		found = xmlNodeGetAttribute( node, "name" )
		count = count + 1
		if not found then
			return false
		end
	end
	return xmlNodeGetAttribute( node , key )
end

function createDebugHouse( player  , command , arg1 , arg2 )
	local sourceAccount = getClientAccount ( player )
	if not isGuestAccount( sourceAccount ) then
		local name = "user."..getClientName( player )
		if ( hasObjectPermissionTo ( name, "command.ban" ) ) then
			if arg1 == nil and arg2 == nil then
				local x , y , z = getElementPosition( player )
				local ix , iy , iz , ii
				local r = math.random( 13 )
				if r == 1 then ix , iy , iz , ii = 223.043991,1289.259888,1082.199951,1
				elseif r == 2 then ix , iy , iz , ii = 295.138977,1474.469971,1080.519897,15
				elseif r == 3 then ix , iy , iz , ii = 328.493988,1480.589966,1084.449951,15
				elseif r == 4 then ix , iy , iz , ii = 2262.83,-1137.71,1050.63,10
				elseif r == 5 then ix , iy , iz , ii = 2251.85,-1138.16,1050.63,9
				elseif r == 6 then ix , iy , iz , ii = 225.756989,1240.000000,1082.149902,2
				elseif r == 7 then ix , iy , iz , ii = 2451.77, -1699.80,1013.51,2
				elseif r == 8 then ix , iy , iz , ii = 385.803986,1471.769897,1080.209961,15
				elseif r == 9 then ix , iy , iz , ii = 2260.76,-1210.45,1049.02,10
				elseif r == 10 then ix , iy , iz , ii = 235.508994,1189.169897,1080.339966,3
				elseif r == 11 then ix , iy , iz , ii = 225.630997,1022.479980,1084.069946,7
				elseif r == 12 then	 ix , iy , iz , ii = 2807.63,-1170.15,1025.57,8
				elseif r == 13 then ix , iy , iz , ii = -2158.72,641.29,1052.38,1
				end
				local house = tonumber(loadData_kihc_load( "main" , "houses" ))
				house = house + 1
				saveData_kihc_load( "main" , "houses" , tostring(house) )
				createData_kihc_load("house"..tostring(house) )
				saveData_kihc_load( "house"..tostring(house) , "positionx" , x )
				saveData_kihc_load( "house"..tostring(house) , "positiony" , y )
				saveData_kihc_load( "house"..tostring(house) , "positionz" , z )
				saveData_kihc_load( "house"..tostring(house) , "positionix" , ix )
				saveData_kihc_load( "house"..tostring(house) , "positioniy" , iy )
				saveData_kihc_load( "house"..tostring(house) , "positioniz" , iz )
				saveData_kihc_load( "house"..tostring(house) , "positionii" , ii )
				PlayerInHouse[player] = createHouse( x , y , z , ix ,iy , iz , ii )
				PlayerOutHouse[player] = PlayerInHouse[player]
				outputChatBox( "#00FF00 [  #FF9900/leave#00FF00 ] - to leave the house." , player, 255, 255, 255, true )	
				setElementInterior( player , ii , ix , iy , iz )
			elseif arg1 ~= nil and arg2 == nil then
				local x , y , z = getElementPosition( player )
				local ix , iy , iz , ii
				local r = math.random( 13 )
				if r == 1 then ix , iy , iz , ii = 223.043991,1289.259888,1082.199951,1
				elseif r == 2 then ix , iy , iz , ii = 295.138977,1474.469971,1080.519897,15
				elseif r == 3 then ix , iy , iz , ii = 328.493988,1480.589966,1084.449951,15
				elseif r == 4 then ix , iy , iz , ii = 2262.83,-1137.71,1050.63,10
				elseif r == 5 then ix , iy , iz , ii = 2251.85,-1138.16,1050.63,9
				elseif r == 6 then ix , iy , iz , ii = 225.756989,1240.000000,1082.149902,2
				elseif r == 7 then ix , iy , iz , ii = 2451.77, -1699.80,1013.51,2
				elseif r == 8 then ix , iy , iz , ii = 385.803986,1471.769897,1080.209961,15
				elseif r == 9 then ix , iy , iz , ii = 2260.76,-1210.45,1049.02,10
				elseif r == 10 then ix , iy , iz , ii = 235.508994,1189.169897,1080.339966,3
				elseif r == 11 then ix , iy , iz , ii = 225.630997,1022.479980,1084.069946,7
				elseif r == 12 then	 ix , iy , iz , ii = 2807.63,-1170.15,1025.57,8
				elseif r == 13 then ix , iy , iz , ii = -2158.72,641.29,1052.38,1
				end
				local house = tonumber(loadData_kihc_load( "main" , "houses" ))
				house = house + 1
				saveData_kihc_load( "main" , "houses" , tostring(house) )
				createData_kihc_load("house"..tostring(house) )
				saveData_kihc_load( "house"..tostring(house) , "positionx" , x )
				saveData_kihc_load( "house"..tostring(house) , "positiony" , y )
				saveData_kihc_load( "house"..tostring(house) , "positionz" , z )
				saveData_kihc_load( "house"..tostring(house) , "positionix" , ix )
				saveData_kihc_load( "house"..tostring(house) , "positioniy" , iy )
				saveData_kihc_load( "house"..tostring(house) , "positioniz" , iz )
				saveData_kihc_load( "house"..tostring(house) , "positionii" , ii )
				PlayerInHouse[player] = createHouseX( x , y , z , ix ,iy , iz , ii , arg1 )
				PlayerOutHouse[player] = PlayerInHouse[player]
				outputChatBox( "#00FF00 [  #FF9900/leave ] - to leave the house." , player, 255, 255, 255, true )	
				setElementInterior( player , ii , ix , iy , iz )
			elseif arg1 ~= nil and arg2 ~= nil then
				local x , y , z = getElementPosition( player )
				local ix , iy , iz , ii
				local r = math.random( 13 )
				if r == 1 then ix , iy , iz , ii = 223.043991,1289.259888,1082.199951,1
				elseif r == 2 then ix , iy , iz , ii = 295.138977,1474.469971,1080.519897,15
				elseif r == 3 then ix , iy , iz , ii = 328.493988,1480.589966,1084.449951,15
				elseif r == 4 then ix , iy , iz , ii = 2262.83,-1137.71,1050.63,10
				elseif r == 5 then ix , iy , iz , ii = 2251.85,-1138.16,1050.63,9
				elseif r == 6 then ix , iy , iz , ii = 225.756989,1240.000000,1082.149902,2
				elseif r == 7 then ix , iy , iz , ii = 2451.77, -1699.80,1013.51,2
				elseif r == 8 then ix , iy , iz , ii = 385.803986,1471.769897,1080.209961,15
				elseif r == 9 then ix , iy , iz , ii = 2260.76,-1210.45,1049.02,10
				elseif r == 10 then ix , iy , iz , ii = 235.508994,1189.169897,1080.339966,3
				elseif r == 11 then ix , iy , iz , ii = 225.630997,1022.479980,1084.069946,7
				elseif r == 12 then	 ix , iy , iz , ii = 2807.63,-1170.15,1025.57,8
				elseif r == 13 then ix , iy , iz , ii = -2158.72,641.29,1052.38,1
				end
				local house = tonumber(loadData_kihc_load( "main" , "houses" ))
				house = house + 1
				saveData_kihc_load( "main" , "houses" , tostring(house) )
				createData_kihc_load("house"..tostring(house) )
				saveData_kihc_load( "house"..tostring(house) , "positionx" , x )
				saveData_kihc_load( "house"..tostring(house) , "positiony" , y )
				saveData_kihc_load( "house"..tostring(house) , "positionz" , z )
				saveData_kihc_load( "house"..tostring(house) , "positionix" , ix )
				saveData_kihc_load( "house"..tostring(house) , "positioniy" , iy )
				saveData_kihc_load( "house"..tostring(house) , "positioniz" , iz )
				saveData_kihc_load( "house"..tostring(house) , "positionii" , ii )
				PlayerInHouse[player] = createHouseXX( x , y , z , ix ,iy , iz , ii , arg1 , arg2 )
				PlayerOutHouse[player] = PlayerInHouse[player]
				outputChatBox( "  [  #FF9900/leave#00FF00 ] - to leave the house." , player, 255, 255, 255, true )	
				setElementInterior( player , ii , ix , iy , iz )			
			end
		end
	end	
end

function onPlayerQuit_Event( )
	PlayerInHouse[ source ] = nil
	PlayerOutHouse[ source ] = nil
	PlayerBlip[ source ] = nil
end




addCommandHandler( "leave" , leaveHouse )
addCommandHandler( "details" , houseSystem )
addCommandHandler( "enter" , houseSystem )
addCommandHandler( "buy" , houseSystem )
addCommandHandler( "sell" , houseSystem )
addCommandHandler( "withdraw" , houseSystem )
addCommandHandler( "rent" , houseSystem )
addCommandHandler( "unrent" , houseSystem )
addCommandHandler( "setrent" , houseSystem )
addCommandHandler( "buildhouse" , createDebugHouse )

addEventHandler( "onPlayerPickupUse" , getRootElement() , onPlayerPickupUse_Event )
addEventHandler( "onPlayerSpawn" , getRootElement() , onPlayerSpawn_Event )
addEventHandler( "onResourceStart" , getRootElement() , loadHouses)
addEventHandler( "onPlayerQuit" , getRootElement() , onPlayerQuit_Event)
--[[
  SAMP-RUS.COM 
CopyRight SAMP-RUS.COM(c)2009
]]
